<?php
function ExtSearch(){
  $trimrequest = trim($_POST['request']); // убираем лишние пробелы в строке поискового запроса
  $request = '%'.str_replace(' ', '%', $trimrequest).'%';

  if (!empty($trimrequest)){
    if ($GLOBALS['islogged']){ //если юзер залогинен берём его настройки отображения контента и статус
      $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT timeformat, timezone FROM users WHERE iduser=? LIMIT 1');
      mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser'])); 
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $timeformat, $timezone);
      mysqli_stmt_fetch($stmt);
      mysqli_stmt_close($stmt);
    }else{ // если гостевой доступ
      $timezone = (int)$_COOKIE['timeshift']; // пробуем взять данные из куков
      if (($timezone < -12) or ($timezone > 12)) $timezone = 0;
      $timeformat = 'H:i d.m.Y';
    }

    $searchtype = (int)substr($_POST['searchtype'], 0, 1);
    if ($searchtype == 1){ // если ищем в сообщениях
      //заголовок страницы
      $html = '<table width="100%" style="background-color: #f5f5f5; font-size: 16px; font-weight: 600"><tr><td height="2px"></td></tr>
      <tr><td><div align="center">Результат поиска по запросу: "'.$trimrequest.'"{num}</div></td></tr><tr><td></td></tr></table>';

      $html .= '<table width="100%" cellspacing="0" cellpadding="0">
      <tr style="background-color: #98c6d2"><td colspan="2" height="1px"></td></tr>'; //начало таблицы сообщений

      //шаблон строки таблицы
      $template = '<tr><td><a name="{id_msg}"></a></td></tr><tr style="background-color: #f5f5f5">
      <td width="15%" valign="top" align="center">
        <div style="min-height: 21px"><div style="padding-top:3px">
        <a title="Перейти на страницу участника" style="font-size: 15px; font-weight: 600" href="./?ai=50&id={id}">{name}</a></div></div>
        <div style="margin-top: 5px">{avatar}</div>
      </td>
      <td width="85%">
        <div><table width="100%" height="21px" cellspacing="0" cellpadding="0"><tr style="background: #e5e5e5">
        <td width="100%" align="left"><span title="Название топика" style="padding-left:6px;font-size:12px;color:#585858">{topic_name}</span></td></tr></table></div>
        <div><table width="100%" height="21px" cellspacing="0" cellpadding="0"><tr style="background: #e5e5e5">
        <td width="17%" align="middle"><span title="Время создания" style="font-size:12px;color:#585858">{createtime}</span></td>
        <td width="1%"></td>
        <td width="17%"><span title="Время правки" style="font-size: 12px;color:#585858">{edittime}</span></td>
        <td width="45%"></td>
        <td width="20%" align="right"><a title="Ссылка на сообщение" style="padding-right:4px;font-size:14px" href="./?ai=9&msg={id_msg}#{id_msg}">№{id_msg}</a></td>
        </tr></table></div>
        <div class="message">{message}</div>
      </td></tr>
      <tr style="background-color: #98c6d2"><td colspan="2" height="1px"></td></tr>'; 

      $topicid = (int)substr($_POST['topicid'], 0, 6);//дополнительные критерии поиска 
      $userid = (int)substr($_POST['userid'], 0, 4);
      if (intval($_COOKIE['iduser']) == $userid){ // если пользователь выбрал сам себя в качестве критерия
        $criterion = 'posts.id_author='."$userid";
      }else{
        $criterion = 'posts.deleted=0 ';
        if ($userid > 0) $criterion .= ' AND posts.id_author='."$userid";
      }
      if ($topicid > 0) $criterion .= ' AND posts.id_topic='."$topicid";

      $stmt = mysqli_prepare($GLOBALS['DB'], 
      'SELECT posts.id_msg, posts.id_author, posts.createtime, posts.edittime, posts.text, posts.deleted, users.name, users.avatar, topics.name
       FROM posts
       LEFT JOIN users ON posts.id_author = users.iduser
       LEFT JOIN topics ON posts.id_topic = topics.id_topic
       WHERE '.$criterion.' AND posts.text LIKE ?
       ORDER BY posts.id_msg ASC'); //результат поиска сортируем по времени
      mysqli_stmt_bind_param($stmt, 's', strval($request));
      mysqli_stmt_execute($stmt);
      mysqli_stmt_store_result($stmt);    
      mysqli_stmt_bind_result($stmt, $id_msg, $id_author, $createtime, $edittime, $text, $deleted, $username, $avatar, $topicname);
      $num = mysqli_stmt_num_rows($stmt);

      if ($num > 0){ //если что-то найдено
        require 'TagFormat.php';
        while (mysqli_stmt_fetch($stmt)){
          $row = $template; //копируем шаблон строки

          $row = str_replace('{id_msg}',$id_msg, $row);

          $date = date_create($createtime); //для отображения смещаем время на указанное в настройках количество часов
          if ($timezone < 0){
            $timeshift = abs($timezone);
            date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
          }else{
            date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
          }
          $createtime = date_format($date, $timeformat);
          $row = str_replace('{createtime}',$createtime, $row);         
    
          if ($edittime != '0000-00-00 00:00:00'){
            $date = date_create($edittime); //для отображения смещаем время на указанное в настройках количество часов
            if ($timezone < 0){
              $timeshift = abs($timezone);
              date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
            }else{
              date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
            }
            $edittime = date_format($date, $timeformat);
            $row = str_replace('{edittime}',$edittime, $row);
          }else{
            $row = str_replace('{edittime}','', $row);
          }

          if (!empty($avatar)) //если аватар есть - выводим его
          $row = str_replace('{avatar}','<a href="./?ai=50&id={id}"><img src="./avatars/'.$avatar.'.jpg" alt="Аватар" title="Перейти на страницу участника"></a>', $row); 
          else $row = str_replace('{avatar}','', $row);

          $row = str_replace('{id}',$id_author, $row);
          $row = str_replace('{name}',$username, $row);
          if ($deleted == 0){ //если сообщение в публичной части форума
            $row = str_replace('{topic_name}', $topicname, $row);
          }else{//если сообщение автора удалено
            $row = str_replace('{topic_name}', $topicname, $row);
            $row = str_replace('f5f5f5', 'c0c0c0', $row);
            $row = str_replace('title="Название топика" ', 'title="Название удалённого топика" ', $row);
          }
          
          $post = TagFormat($text); // сразу вставляем теги форматирования
          $words = explode('%', $request); //выделяем слова поиска цветом
          foreach ($words as $value){
            $len = strlen($value);
            $pos = -$len - 33;
            while (1){
              $pos = stripos(mb_strtolower($post), mb_strtolower($value), $pos + $len + 33);
              if ($pos === false){
                break;
              }else{
                $post = substr_replace($post, '</span>', $pos + $len, 0);
                $post = substr_replace($post, '<span style="background:#FFFF00">', $pos, 0);
              }
            }
          }  
          $row = str_replace('{message}', $post, $row); //выводим имя и сообщение со всеми тэгами в конце, чтобы исключить риски замены данных в тексте сообщения

          $html .= $row;
        }
        $html = str_replace('{num}',' ('.$num.')', $html);
      }else{ //если ничего не найдено
        $html = str_replace('{num}','', $html);
        $html .= '<tr class="CellsOldPost" style="height:34px"><td colspan="3"><div align="center">По Вашему запросу ничего не найдено</div></td></tr>';
      }
      mysqli_stmt_close($stmt);
      $html .= '</table>';

    }else{// если ищем в названиях топиков
      //заголовок страницы
      $html = '<table width="100%" style="background-color: #f5f5f5; font-size: 16px; font-weight: 600"><tr><td height="2px"></td></tr>
      <tr><td><div align="center">Результат поиска по запросу: "'.$trimrequest.'"</div></td></tr><tr><td></td></tr></table>';

      $html .= '<table width="100%" cellspacing="1" cellpadding="3" style="background-color: #ffffff" border="0">
      <tr style="background-color: #d2d2d2; text-align: left; font-size: 14px; font-weight: 600; height: 26px">
      <td width="72%" align="left">Название топика</td>
      <td width="17%" align="left">Автор</td>
      <td width="11%" align="left">Дата</td></tr>'; //начало таблицы результата

      //шаблон строки таблицы
      $template = '<tr class="CellsOldPost">
      <td><div><a title="Перейти в топик" href="./?ai=9&id={id_topic}" target="_blank">{topicname}</a></div></td>
      <td><a title="Перейти на страницу участника" href="./?ai=50&id={id}">{username}</a></td>
      <td>{createtime}</td>
      </tr>';

      $criterion = ''; //дополнительные критерии поиска      
      $topicid = (int)substr($_POST['topicid'], 0, 6);
      $userid = (int)substr($_POST['userid'], 0, 4);
      if ($userid > 0) $criterion .= ' AND topics.id_author='."$userid";
      if ($topicid > 0) $criterion .= ' AND topics.id_topic='."$topicid";

      $stmt = mysqli_prepare($GLOBALS['DB'], 
      'SELECT topics.id_topic, topics.id_author, topics.createtime, users.name, topics.name
       FROM topics
       LEFT JOIN users ON topics.id_author = users.iduser
       WHERE topics.deleted=0 '.$criterion.' AND topics.name LIKE ?
       ORDER BY users.name, topics.id_topic DESC'); //результат поиска сортируем по автору и по времени
      mysqli_stmt_bind_param($stmt, 's', strval($request));
      mysqli_stmt_execute($stmt);
      mysqli_stmt_store_result($stmt);    
      mysqli_stmt_bind_result($stmt, $id_topic, $id_author, $createtime, $username, $topicname);
      $num = mysqli_stmt_num_rows($stmt);

      if ($num > 0){ //если что-то найдено
        while (mysqli_stmt_fetch($stmt)){
          $row = $template; //копируем шаблон строки
          $row = str_replace('{id}',$id_author, $row);
          $row = str_replace('{id_topic}',$id_topic, $row);

          $date = date_create($createtime); //для отображения смещаем время на указанное в настройках количество часов
          if ($timezone < 0){
            $timeshift = abs($timezone);
            date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
          }else{
            date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
          }
          $createtime = date_format($date, 'Y.m.d');
          $row = str_replace('{createtime}',$createtime, $row);
          $row = str_replace('{topicname}',$topicname, $row);
          $row = str_replace('{username}',$username, $row);
          $html .= $row;
        }
      }else{ //если ничего не найдено
        $html .= '<tr class="CellsOldPost" style="height:34px"><td colspan="3"><div align="center">По Вашему запросу ничего не найдено</div></td></tr>';
      }
      mysqli_stmt_close($stmt);
      $html .= '</table>';
    }
  }else{ //если поисковый запрос пустой
    $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      <tr><td><div align="center">Поисковый запрос не может быть пустым</div></td></tr><tr><td height="10px"></td></tr></table>';
  }
  return $html;
}
?>