<?php
function ShowEditTopicForm(){
  $id = (int)substr($_GET['id'], 0, 6); //на всякий случай ограничиваем длину

  if ($GLOBALS['islogged']){ //если есть логин
    if (isset($_SESSION['EditTopicForm'])){ // если форма уже была заполнена но с ошибками, все данные берём из сессии
      $error = $_SESSION['EditTopicForm']['error'];
      $topic = $_SESSION['EditTopicForm']['topic'];
      $topictype = $_SESSION['EditTopicForm']['topictype'];
      unset($_SESSION['EditTopicForm']);
    }else{ //в противном случае все поля по умолчанию
      $error = '';
      $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT name, type FROM topics WHERE id_topic=? LIMIT 1");
      mysqli_stmt_bind_param($stmt, 'i', $id);
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $topic, $topictype); //название и тип топика
      mysqli_stmt_fetch($stmt);
      mysqli_stmt_close($stmt);
    }
  }else{ //если логона нету
    $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      <tr><td><div align="center">Авторизуйтесь, чтобы редактировать топики.</div></td></tr><tr><td height="10px"></td></tr></table>';  
    return $html; //не используем сообщения ai=200 чтобы после авторизации вернуться на ту же страницу
    exit();
  }

  $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT id_author FROM topics WHERE id_topic=? LIMIT 1'); //проверяем есть ли топик и его автор
  mysqli_stmt_bind_param($stmt, 'i', $id);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $id_author); 
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if (!isset($id_author)){
    $_SESSION['msg'] = 'Такого топика нет.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');
    exit();
  }

  if ($id_author != $_COOKIE['iduser']){
    $_SESSION['msg'] = 'Нельзя редактировать чужие топики.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');  
    exit();
  }

  $html = file_get_contents('./templates/EditTopicForm.html');
  $html = str_replace('{error}', $error, $html);
  if ($topictype == 1) $html = str_replace('id="cht1"', 'id="cht1" checked', $html);
  else $html = str_replace('id="cht2"', 'id="cht2" checked', $html);
  $html = str_replace('{topic}', $topic, $html);
  $html = str_replace('{id_topic}', $id, $html);

  return $html;
}
?>