<?php
function AddNewUserForm()
{
  if (isset($_COOKIE['iduser']) and isset($_COOKIE['hash'])) //если юзер авторизован то вместо регистрации перенапраляем на начальную страницу
  {
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName']);
    else header('Location: http://'.$GLOBALS['HostName']);
    exit();
  }
 
  // Если ранее форма была заполнена, используем уже введённые данные
  if (isset($_SESSION['addNewUserForm'])){
    $error = $_SESSION['addNewUserForm']['error'];
    $name = htmlspecialchars($_SESSION['addNewUserForm']['name']);
    $email = htmlspecialchars($_SESSION['addNewUserForm']['email']);
    $password = htmlspecialchars($_SESSION['addNewUserForm']['password']);
    $confirm = htmlspecialchars($_SESSION['addNewUserForm']['confirm']);
    unset($_SESSION['addNewUserForm']);
  } else {
    $error = '';
    $name = '';
    $email = '';
    $password = '';
    $confirm = '';
  }
  $html = file_get_contents('./templates/addNewUserForm.html');
  $html = str_replace( '{error}', $error, $html);
  $html = str_replace( '{name}', $name, $html);
  $html = str_replace( '{email}', $email, $html);
  $html = str_replace( '{password}', $password, $html);
  $html = str_replace( '{confirm}', $confirm, $html);
  return $html;
}
?>