function CreateAsyncObj(){
  if (window.XMLHttpRequest){
    try {return new XMLHttpRequest();} catch (e){}// для IE7+, Firefox, Chrome, Opera, Safari
  }else if (window.ActiveXObject){
    try {return new ActiveXObject('Msxml2.XMLHTTP');} catch (e){} // для IE6, IE5
    try {return new ActiveXObject('Microsoft.XMLHTTP');} catch (e){}
  }
  return null;
}

function DisplayResult(message){
  data = JSON.parse(message);
  switch (data.type){
    case 1: //обычное простое однострочное сообщение
      document.getElementById("AcceptAsync").innerHTML = data.msg;
      break;
    case 2: //сообщение после голосования за жалобу
      document.getElementById("AcceptAsync").innerHTML = data.msg;
      document.getElementById("VoteBut").innerHTML = '';
      document.getElementById("opt1").innerHTML = '';
      document.getElementById("opt2").innerHTML = '';
      document.getElementById("opt3").innerHTML = '';
      document.getElementById("yes").innerHTML = data.yes;
      document.getElementById("abs").innerHTML = data.abs;
      document.getElementById("no").innerHTML = data.no;
      document.getElementById("yeslist").innerHTML = data.yeslist;
      document.getElementById("abslist").innerHTML = data.abslist;
      document.getElementById("nolist").innerHTML = data.nolist;
      break;
    case 3: //обычное простое однострочное сообщение в поле AsyncMsg
      document.getElementById("AsyncMsg").innerHTML = data.msg;
      break;
    case 4: //переход на ту же страницу форума после удаления сообщения
      document.location.href = data.msg;
      break;
    case 5: //изменение метки о прочтении топика
      if (data.state == 1){document.getElementById("T"+data.id).className = "CellsNewPost";
      }else{document.getElementById("T"+data.id).className = "CellsOldPost";}
      break;
    case 6: //лайки/дизлайки
      var id = "L"+data.id;
      document.getElementById(id).innerHTML = data.msg;
      document.getElementById(id).style.marginTop = "5px";
      document.getElementById(id).style.paddingRight = "5px";
      document.getElementById(id).style.paddingLeft = "5px";
      break;
    case 7: //отмена лайка/дизлайка
      var id = "L"+data.id;
      document.getElementById(id).innerHTML = data.msg;
      document.getElementById(id).style.marginTop = "0px";
      document.getElementById(id).style.paddingRight = "0px";
      document.getElementById(id).style.paddingLeft = "0px";
      break;
    case 100:
      document.getElementById("ServerTime").innerHTML = data.msg;
      break;
  }
}

function AsyncAct(data){
  var AsyncObj = CreateAsyncObj();
  if (AsyncObj){
	AsyncObj.open("POST", "./GetAsync.php", true);
	AsyncObj.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=utf-8");
    AsyncObj.onreadystatechange=function(){ // колл-бэк функция
      if (AsyncObj.readyState==4 && AsyncObj.status==200){
        var text = AsyncObj.responseText;
        var id = text.substring(0, 8);
        switch (id){
          case '-=&#%$=-'://сложное многострочное сообщение
            text = text.substring(8);
            document.getElementById("AcceptAsync").innerHTML = text;
            break;
          case '-=*@^!=-'://список лайкнувших
            text = text.substring(8);
            var msgid = text.substring(0, 7);
            var id = "SL"+String(Number(msgid));
            document.getElementById(id).title = text.substring(7);
            break;
          case '-=!^@*=-'://список дизлайкнувших
            text = text.substring(8);
            var msgid = text.substring(0, 7);
            var id = "SD"+String(Number(msgid));
            document.getElementById(id).title = text.substring(7);
            break;
          default://декодируем как JSON
            DisplayResult(text);
        }
      }
    }
    AsyncObj.send(data);
  }else{
	  DisplayResult("Ваш броузер не поддерживает AJAX");
  }
}